pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT > Class Template Reference
Module keypoints

ISSKeypoint3D detects the Intrinsic Shape Signatures keypoints for a given point cloud. More...

`#include <pcl/keypoints/iss_3d.h>`

Inheritance diagram for pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >:

## Public Types

typedef boost::shared_ptr< ISSKeypoint3D< PointInT, PointOutT, NormalT > > | Ptr
typedef boost::shared_ptr< const ISSKeypoint3D< PointInT, PointOutT, NormalT > > | ConstPtr
typedef Keypoint< PointInT, PointOutT >::PointCloudIn | PointCloudIn
typedef Keypoint< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef pcl::PointCloud< NormalT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
typedef pcl::octree::OctreePointCloudSearch< PointInT > | OctreeSearchIn
typedef OctreeSearchIn::Ptr | OctreeSearchInPtr
Public Types inherited from pcl::Keypoint< PointInT, PointOutT >
typedef boost::shared_ptr< Keypoint< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Keypoint< PointInT, PointOutT > > | ConstPtr
typedef PCLBase< PointInT > | BaseClass
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(int, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, int index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ISSKeypoint3D (double salient_radius=0.0001)
| Constructor. More...
| ~ISSKeypoint3D ()
| Destructor. More...
void | setSalientRadius (double salient_radius)
| Set the radius of the spherical neighborhood used to compute the scatter matrix. More...
void | setNonMaxRadius (double non_max_radius)
| Set the radius for the application of the non maxima supression algorithm. More...
void | setNormalRadius (double normal_radius)
| Set the radius used for the estimation of the surface normals of the input cloud. More...
void | setBorderRadius (double border_radius)
| Set the radius used for the estimation of the boundary points. More...
void | setThreshold21 (double gamma_21)
| Set the upper bound on the ratio between the second and the first eigenvalue. More...
void | setThreshold32 (double gamma_32)
| Set the upper bound on the ratio between the third and the second eigenvalue. More...
void | setMinNeighbors (int min_neighbors)
| Set the minimum number of neighbors that has to be found while applying the non maxima suppression algorithm. More...
void | setNormals (const PointCloudNConstPtr &normals)
| Set the normals if pre-calculated normals are available. More...
void | setAngleThreshold (float angle)
| Set the decision boundary (angle threshold) that marks points as boundary or regular. More...
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use. More...
Public Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
| Keypoint ()
void | harrisCorner (ImageType &output, ImageType &input, const float sigma_d, const float sigma_i, const float alpha, const float thresh)
void | hessianBlob (ImageType &output, ImageType &input, const float sigma, bool SCALE)
void | hessianBlob (ImageType &output, ImageType &input, const float start_scale, const float scaling_factor, const int num_scales)
void | imageElementMultiply (ImageType &output, ImageType &input1, ImageType &input2)
| Keypoint ()
| Empty constructor. More...
virtual | ~Keypoint ()
| Empty destructor. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for. More...
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
double | getSearchParameter ()
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors. More...
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
int | searchForNeighbors (int index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

bool * | getBoundaryPoints (PointCloudIn &input, double border_radius, float angle_threshold)
| Compute the boundary points for the given input cloud. More...
void | getScatterMatrix (const int &current_index, Eigen::Matrix3d &cov_m)
| Compute the scatter matrix for a point index. More...
bool | initCompute ()
| Perform the initial checks before computing the keypoints. More...
void | detectKeypoints (PointCloudOut &output)
| Detect the keypoints by performing the EVD of the scatter matrix. More...
Protected Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

double | salient_radius_
| The radius of the spherical neighborhood used to compute the scatter matrix. More...
double | non_max_radius_
| The non maxima suppression radius. More...
double | normal_radius_
| The radius used to compute the normals of the input cloud. More...
double | border_radius_
| The radius used to compute the boundary points of the input cloud. More...
double | gamma_21_
| The upper bound on the ratio between the second and the first eigenvalue returned by the EVD. More...
double | gamma_32_
| The upper bound on the ratio between the third and the second eigenvalue returned by the EVD. More...
double * | third_eigen_value_
| Store the third eigen value associated to each point in the input cloud. More...
bool * | edge_points_
| Store the information about the boundary points of the input cloud. More...
int | min_neighbors_
| Minimum number of neighbors that has to be found while applying the non maxima suppression algorithm. More...
PointCloudNConstPtr | normals_
| The cloud of normals related to the input surface. More...
float | angle_threshold_
| The decision boundary (angle threshold) that marks points as boundary or regular. More...
unsigned int | threads_
| The number of threads that has to be used by the scheduler. More...
Protected Attributes inherited from pcl::Keypoint< PointInT, PointOutT >
std::string | name_
| The key point detection method's name. More...
SearchMethod | search_method_
| The search method template for indices. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>
class pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >

ISSKeypoint3D detects the Intrinsic Shape Signatures keypoints for a given point cloud.

This class is based on a particular implementation made by Federico Tombari and Samuele Salti and it has been explicitly adapted to PCL.

For more information about the original ISS detector, see:

  Yu Zhong, “Intrinsic shape signatures: A shape descriptor for 3D object recognition,” Computer Vision Workshops (ICCV Workshops), 2009 IEEE 12th International Conference on , vol., no., pp.689-696, Sept. 27 2009-Oct. 4 2009

Code example:

pcl::PointCloud<pcl::PointXYZRGBA>::Ptr model (new pcl::PointCloud<pcl::PointXYZRGBA> ());;
pcl::PointCloud<pcl::PointXYZRGBA>::Ptr model_keypoints (new pcl::PointCloud<pcl::PointXYZRGBA> ());
pcl::search::KdTree<pcl::PointXYZRGBA>::Ptr tree (new pcl::search::KdTree<pcl::PointXYZRGBA> ());
// Fill in the model cloud
double model_resolution;
// Compute model_resolution
pcl::ISSKeypoint3D<pcl::PointXYZRGBA, pcl::PointXYZRGBA> iss_detector;
iss_detector.setSearchMethod (tree);
iss_detector.setSalientRadius (6 * model_resolution);
iss_detector.setNonMaxRadius (4 * model_resolution);
iss_detector.setThreshold21 (0.975);
iss_detector.setThreshold32 (0.975);
iss_detector.setMinNeighbors (5);
iss_detector.setNumberOfThreads (4);
iss_detector.setInputCloud (model);
iss_detector.compute (*model_keypoints);

Author
  Gioia Ballin

Definition at line 85 of file iss_3d.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

typedef boost::shared_ptr<const ISSKeypoint3D<PointInT, PointOutT, NormalT> > pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::ConstPtr

Definition at line 89 of file iss_3d.h.

## OctreeSearchIn

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

typedef pcl::octree::OctreePointCloudSearch<PointInT> pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::OctreeSearchIn

Definition at line 98 of file iss_3d.h.

## OctreeSearchInPtr

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

typedef OctreeSearchIn::Ptr pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::OctreeSearchInPtr

Definition at line 99 of file iss_3d.h.

## PointCloudIn

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

typedef Keypoint<PointInT, PointOutT>::PointCloudIn pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::PointCloudIn

Definition at line 91 of file iss_3d.h.

## PointCloudN

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

typedef pcl::PointCloud<NormalT> pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::PointCloudN

Definition at line 94 of file iss_3d.h.

## PointCloudNConstPtr

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

typedef PointCloudN::ConstPtr pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::PointCloudNConstPtr

Definition at line 96 of file iss_3d.h.

## PointCloudNPtr

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

typedef PointCloudN::Ptr pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::PointCloudNPtr

Definition at line 95 of file iss_3d.h.

## PointCloudOut

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

typedef Keypoint<PointInT, PointOutT>::PointCloudOut pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::PointCloudOut

Definition at line 92 of file iss_3d.h.

## Ptr

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

typedef boost::shared_ptr<ISSKeypoint3D<PointInT, PointOutT, NormalT> > pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::Ptr

Definition at line 88 of file iss_3d.h.

## Constructor & Destructor Documentation

## ISSKeypoint3D()

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::ISSKeypoint3D | ( | double | salient_radius = `0.0001` | ) |

inline

Constructor.

Parameters

  [in] | salient_radius | the radius of the spherical neighborhood used to compute the scatter matrix.

Definition at line 112 of file iss_3d.h.

References pcl::Keypoint< PointInT, PointOutT >::name_, pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::salient_radius_, and pcl::Keypoint< PointInT, PointOutT >::search_radius_.

## ~ISSKeypoint3D()

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D | ( |  | ) |

inline

Destructor.

Definition at line 131 of file iss_3d.h.

References pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::edge_points_, pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setBorderRadius(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setMinNeighbors(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNonMaxRadius(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNormalRadius(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNormals(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setSalientRadius(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setThreshold21(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setThreshold32(), and pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::third_eigen_value_.

## Member Function Documentation

## detectKeypoints()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints | ( | PointCloudOut & | output | ) |

protected virtual

Detect the keypoints by performing the EVD of the scatter matrix.

Parameters

  [out] | output | the resultant cloud of keypoints

Implements pcl::Keypoint< PointInT, PointOutT >.

Definition at line 293 of file iss_3d.hpp.

References pcl::PointCloud< PointT >::header, pcl::PointCloud< PointT >::height, pcl::isFinite(), pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNumberOfThreads().

## getBoundaryPoints()

template<typename PointInT , typename PointOutT , typename NormalT >

bool * pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::getBoundaryPoints | ( | PointCloudIn & | input,
|  | double | border_radius,
|  | float | angle_threshold
| ) |  |

protected

Compute the boundary points for the given input cloud.

Parameters

  [in] | input | the input cloud
  [in] | border_radius | the radius used to compute the boundary points
  [in] | angle_threshold | the decision boundary that marks the points as boundary

Returns
  the vector of boolean values in which the information about the boundary points is stored

Definition at line 105 of file iss_3d.hpp.

References pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::getCoordinateSystemOnPlane(), pcl::BoundaryEstimation< PointInT, PointNT, PointOutT >::isBoundaryPoint(), pcl::isFinite(), pcl::PointCloud< PointT >::points, pcl::PCLBase< PointInT >::setInputCloud(), and pcl::PointCloud< PointT >::size().

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNumberOfThreads().

## getScatterMatrix()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::getScatterMatrix | ( | const int & | current_index,
|  | Eigen::Matrix3d & | cov_m
| ) |  |

protected

Compute the scatter matrix for a point index.

Parameters

  [in] | current_index | the index of the point
  [out] | cov_m | the point scatter matrix

Definition at line 149 of file iss_3d.hpp.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNumberOfThreads().

## initCompute()

template<typename PointInT , typename PointOutT , typename NormalT >

bool pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::initCompute | ( |  | ) |

protected virtual

Perform the initial checks before computing the keypoints.

Returns
  true if all the checks are passed, false otherwise

Reimplemented from pcl::Keypoint< PointInT, PointOutT >.

Definition at line 199 of file iss_3d.hpp.

References pcl::Feature< PointInT, PointOutT >::compute(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setInputCloud(), pcl::NormalEstimation< PointInT, PointOutT >::setInputCloud(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setNormalEstimationMethod(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setNormalSmoothingSize(), and pcl::Feature< PointInT, PointOutT >::setRadiusSearch().

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNumberOfThreads().

## setAngleThreshold()

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setAngleThreshold | ( | float | angle | ) |

inline

Set the decision boundary (angle threshold) that marks points as boundary or regular.

(default )

Parameters

  [in] | angle | the angle threshold

Definition at line 192 of file iss_3d.h.

References pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::angle_threshold_.

## setBorderRadius()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setBorderRadius | ( | double | border_radius | ) |

Set the radius used for the estimation of the boundary points.

If the radius is too large, the temporal performances of the detector may degrade significantly.

Parameters

  [in] | border_radius | the radius used to compute the boundary points

Definition at line 70 of file iss_3d.hpp.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## setMinNeighbors()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setMinNeighbors | ( | int | min_neighbors | ) |

Set the minimum number of neighbors that has to be found while applying the non maxima suppression algorithm.

Parameters

  [in] | min_neighbors | the minimum number of neighbors required

Definition at line 91 of file iss_3d.hpp.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## setNonMaxRadius()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNonMaxRadius | ( | double | non_max_radius | ) |

Set the radius for the application of the non maxima supression algorithm.

Parameters

  [in] | non_max_radius | the non maxima suppression radius

Definition at line 56 of file iss_3d.hpp.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## setNormalRadius()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNormalRadius | ( | double | normal_radius | ) |

Set the radius used for the estimation of the surface normals of the input cloud.

If the radius is too large, the temporal performances of the detector may degrade significantly.

Parameters

  [in] | normal_radius | the radius used to estimate surface normals

Definition at line 63 of file iss_3d.hpp.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## setNormals()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNormals | ( | const PointCloudNConstPtr & | normals | ) |

Set the normals if pre-calculated normals are available.

Parameters

  [in] | normals | the given cloud of normals

Definition at line 98 of file iss_3d.hpp.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## setNumberOfThreads()

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNumberOfThreads | ( | unsigned int | nr_threads = `0` | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  [in] | nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 201 of file iss_3d.h.

References pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::getBoundaryPoints(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::getScatterMatrix(), pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::initCompute(), and pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::threads_.

## setSalientRadius()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setSalientRadius | ( | double | salient_radius | ) |

Set the radius of the spherical neighborhood used to compute the scatter matrix.

Parameters

  [in] | salient_radius | the radius of the spherical neighborhood

Definition at line 49 of file iss_3d.hpp.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## setThreshold21()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setThreshold21 | ( | double | gamma_21 | ) |

Set the upper bound on the ratio between the second and the first eigenvalue.

Parameters

  [in] | gamma_21 | the upper bound on the ratio between the second and the first eigenvalue

Definition at line 77 of file iss_3d.hpp.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## setThreshold32()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setThreshold32 | ( | double | gamma_32 | ) |

Set the upper bound on the ratio between the third and the second eigenvalue.

Parameters

  [in] | gamma_32 | the upper bound on the ratio between the third and the second eigenvalue

Definition at line 84 of file iss_3d.hpp.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## Member Data Documentation

## angle_threshold_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

float pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::angle_threshold_

protected

The decision boundary (angle threshold) that marks points as boundary or regular.

(default )

Definition at line 265 of file iss_3d.h.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setAngleThreshold().

## border_radius_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

double pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::border_radius_

protected

The radius used to compute the boundary points of the input cloud.

Definition at line 244 of file iss_3d.h.

## edge_points_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

bool* pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::edge_points_

protected

Store the information about the boundary points of the input cloud.

Definition at line 256 of file iss_3d.h.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## gamma_21_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

double pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::gamma_21_

protected

The upper bound on the ratio between the second and the first eigenvalue returned by the EVD.

Definition at line 247 of file iss_3d.h.

## gamma_32_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

double pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::gamma_32_

protected

The upper bound on the ratio between the third and the second eigenvalue returned by the EVD.

Definition at line 250 of file iss_3d.h.

## min_neighbors_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

int pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::min_neighbors_

protected

Minimum number of neighbors that has to be found while applying the non maxima suppression algorithm.

Definition at line 259 of file iss_3d.h.

## non_max_radius_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

double pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::non_max_radius_

protected

The non maxima suppression radius.

Definition at line 238 of file iss_3d.h.

## normal_radius_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

double pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::normal_radius_

protected

The radius used to compute the normals of the input cloud.

Definition at line 241 of file iss_3d.h.

## normals_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

PointCloudNConstPtr pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::normals_

protected

The cloud of normals related to the input surface.

Definition at line 262 of file iss_3d.h.

## salient_radius_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

double pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::salient_radius_

protected

The radius of the spherical neighborhood used to compute the scatter matrix.

Definition at line 235 of file iss_3d.h.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::ISSKeypoint3D().

## third_eigen_value_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

double* pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::third_eigen_value_

protected

Store the third eigen value associated to each point in the input cloud.

Definition at line 253 of file iss_3d.h.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::~ISSKeypoint3D().

## threads_

template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>

unsigned int pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::threads_

protected

The number of threads that has to be used by the scheduler.

Definition at line 268 of file iss_3d.h.

Referenced by pcl::ISSKeypoint3D< PointInT, PointOutT, NormalT >::setNumberOfThreads().

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/keypoints/include/pcl/keypoints/iss_3d.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/keypoints/include/pcl/keypoints/impl/iss_3d.hpp